## Script (Python) "link_tree_builder"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=tree_root,navBatchStart=0,batchSize=None,rolesSeeHiddenContent=['Manager']
##title=Standard Classifieds Tree
##
from Products.CMFPlone.StatelessTreeNav import StatelessTreeBuilder, \
                                               wrap_obj
from Products.CMFCore.utils import getToolByName
from Products.Classified.utils import isInsideOf, checkPublished, \
                                       sort_by_attr, \
                                       sort_by_attr_inplace

pct = getToolByName(context, 'portal_classifieds')

if batchSize is None:
    batchSize = pct.batch_size

navBatchStart = int(navBatchStart)
batchSize = int(batchSize)

def childFinder(obj, folderishOnly = 1):
    res = obj.objectValues(['ClassifiedCategory'])
    res = [o for o in res if o.validCategory(rolesSeeHiddenContent)]
    # Uncomment if you want to see classifieds in the classified_tree_slot
    #res.extend([wrap_obj(o, obj) for o in
    #            obj.searchCategoryClassifieds(rolesSeeHiddenContent)])
    sort_by_attr_inplace(res, 'title')
    return res
    
# "context" modification when it is outside of the tree_root context
context_wrapped = context
if not isInsideOf(context_wrapped, tree_root):
    context_wrapped = tree_root

tb = StatelessTreeBuilder(context_wrapped, topObject = tree_root,
                          topMetaType = 'ClassifiedCategoryFolder',
                          childFinder = childFinder, includeTop = 0,
                          forceParentsInBatch = 1)

res = tb.buildFlatMenuStructure(batchSize = batchSize,
                                batchStart = navBatchStart)

for r in res['list']:
    r['published'] = checkPublished(context, r['object'])
    
return res