from AccessControl import ModuleSecurityInfo
from Products.CMFCore.utils import getToolByName

ModuleSecurityInfo('Products.Classified.utils').declarePublic('isInsideOf')
ModuleSecurityInfo('Products.Classified.utils').declarePublic('checkPublished')
ModuleSecurityInfo('Products.Classified.utils').declarePublic('sort_by_attr')
ModuleSecurityInfo('Products.Classified.utils').declarePublic('sort_by_attr_inplace')

def isInsideOf(obj1, obj2):
    return obj2 in obj1.aq_chain

def checkPublished(self, o):
    workflow_tool = getToolByName(self, 'portal_workflow')
    try:
        if workflow_tool.getInfoFor(o, 'review_state', '') != 'published':
            return 0
        now = self.ZopeTime()
        start_pub = getattr(o, 'effective_date', None)
        end_pub = getattr(o, 'expiration_date', None)
        if start_pub and start_pub > now:
            return 0
        if end_pub and now > end_pub:
            return 0
    except:
        return 0
    return 1

def sort_by_attr(seq, attr):
    import operator
    intermed = map(None, map(getattr, seq, (attr,) * len(seq)),
                   xrange(len(seq)), seq)
    intermed.sort()
    return map(operator.getitem, intermed, (-1,) * len(intermed))

def sort_by_attr_inplace(lst, attr):
    lst[:] = sort_by_attr(lst, attr)